<template>
  <div class="scroll-spy-container" ref="container">
    <slot />
  </div>
</template>

<script>
export default {
  name: "ScrollSpy",
  data() {
    return {
      top: 0,
      scroll: -1,
      triggered: false
    }
  },
  props: {
    offset: {
      type: Number,
      default: 0
    }
  },
  methods: {
    onScroll() {
      this.scroll = window.scrollY;
      if (this.triggered === false && this.scroll >= this.top - this.offset) {
        this.triggered = true;
      }
    }
  },
  watch: {
    triggered() {
      this.$emit('trigger');
    }
  },
  mounted() {
    window.addEventListener('scroll', this.onScroll);
    this.top = this.$refs.container.getBoundingClientRect().top;
    this.onScroll();
  },
  beforeDestroy() {
    window.removeEventListener('scroll', this.onScroll);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

</style>